/*
 * Copyright (c) 2010 Apple Inc. All rights reserved.
 *
 * @APPLE_LICENSE_HEADER_START@
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1.  Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 * 2.  Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 * 3.  Neither the name of Apple Inc. ("Apple") nor the names of its
 *     contributors may be used to endorse or promote products derived from
 *     this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE AND ITS CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL APPLE OR ITS CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Portions of this software have been released under the following terms:
 *
 * (c) Copyright 1989-1993 OPEN SOFTWARE FOUNDATION, INC.
 * (c) Copyright 1989-1993 HEWLETT-PACKARD COMPANY
 * (c) Copyright 1989-1993 DIGITAL EQUIPMENT CORPORATION
 *
 * To anyone who acknowledges that this file is provided "AS IS"
 * without any express or implied warranty:
 * permission to use, copy, modify, and distribute this file for any
 * purpose is hereby granted without fee, provided that the above
 * copyright notices and this notice appears in all source code copies,
 * and that none of the names of Open Software Foundation, Inc., Hewlett-
 * Packard Company or Digital Equipment Corporation be used
 * in advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  Neither Open Software
 * Foundation, Inc., Hewlett-Packard Company nor Digital
 * Equipment Corporation makes any representations about the suitability
 * of this software for any purpose.
 *
 * Copyright (c) 2007, Novell, Inc. All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1.  Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 * 2.  Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 * 3.  Neither the name of Novell Inc. nor the names of its contributors
 *     may be used to endorse or promote products derived from this
 *     this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * @APPLE_LICENSE_HEADER_END@
 */

/* Generated by IDL compiler version FreeDCE/DCOM 1.1.0.7 with GNU Flex/Bison */
#ifndef sec_id_base_v0_0_included
#define sec_id_base_v0_0_included
#ifndef IDLBASE_H
#include <dce/idlbase.h>
#endif

#ifdef __cplusplus
    extern "C" {
#endif

#ifndef nbase_v0_0_included
#include <dce/nbase.h>
#endif
typedef struct sec_id_t {
idl_uuid_t uuid;
idl_char *name;
} sec_id_t;
typedef struct sec_id_foreign_t {
sec_id_t id;
sec_id_t realm;
} sec_id_foreign_t;
typedef struct sec_id_foreign_groupset_t {
sec_id_t realm;
unsigned16 num_groups;
sec_id_t *groups;
} sec_id_foreign_groupset_t;
typedef enum {sec_id_pac_format_v1 = 0,
sec_id_pac_format_ms = 1} sec_id_pac_format_t;
typedef struct sec_id_pac_format_v1_t {
sec_id_t realm;
sec_id_t principal;
sec_id_t group;
unsigned16 num_groups;
unsigned16 num_foreign_groups;
sec_id_t *groups;
sec_id_t *foreign_groups;
} sec_id_pac_format_v1_t;
typedef struct  {
FILETIME logon_time;
FILETIME logoff_time;
FILETIME kickoff_time;
FILETIME pwd_last_set_time;
FILETIME pwd_can_change_time;
FILETIME pwd_must_change_time;
UNICODE_STRING acct_name;
UNICODE_STRING full_name;
UNICODE_STRING script;
UNICODE_STRING profile;
UNICODE_STRING home;
UNICODE_STRING home_drive;
USHORT logon_count;
USHORT bad_pwd_count;
ULONG user_rid;
ULONG group_rid;
ULONG num_groups;
PGROUP_MEMBERSHIP group_ids;
ULONG user_flags;
USHORT user_sess_key[16];
UNICODE_STRING logon_server;
UNICODE_STRING logon_domain;
PISID domain_sid;
ULONG padding[10];
ULONG num_other_sids;
PSID_AND_ATTRIBUTES other_sids;
} sec_id_pac_format_ms_t;
typedef union sec_id_pac_rep_t {
/* case(s): 0 */
sec_id_pac_format_v1_t v1_pac;
/* case(s): 1 */
sec_id_pac_format_ms_t ms_pac;
} sec_id_pac_rep_t;
typedef struct sec_id_pac_t {
sec_id_pac_format_t pac_type;
boolean32 authenticated;
sec_id_pac_rep_t pac;
} sec_id_pac_t;
typedef struct sec_id_pickled_pac_t {
ndr_format_t format_label;
unsigned32 num_bytes;
idl_byte pickled_data[1];
} sec_id_pickled_pac_t;

#ifdef __cplusplus
    }
#endif

#endif
